      subroutine AddBondsC(jBondGroup,nc,nc1)
      implicit none
c
      include 'includeSystemSize.f'
      include 'includeGraphEnumeration.f'
      include 'includeCoveringCell.f'
c
      integer :: jBondGroup,jBond,nc,nc1,  i,j,ic, iBond, nj
      integer(kind=kShortInt)  :: xadd
c
c     This routine expects to find nc bond configs filled up to bond
c     jbond-1 in a file opened on unit 1, except when we're assigned the
c     first bond.
c
c     This routine expects to write nc1 bond configs filled up to bond
c     jbond but without symmetry testing to unit 2.
c
      nc1=0
c
c ---      Loop over configurations at previous level ---
c
c      do jBond=1,BondGroup(jBondGroup,0)
      do ic=1,nc
c
c      Count incoming and outgoing lines on each vertex
c
c
         do j=1,nVertices
            vin0(j)=0
            vout0(j)=0
         end do

         if(jBondGroup.gt.1) then
            nj=BondGroup(jBondGroup-1,0)
            jBond=BondGroup(jBondGroup-1,nj)
            read(1) (x(iBond),iBond=1,jBond)
c=============================================
c$$$            write(3,*) ' right after x read into AddBondsC '
c$$$            write(3,*) (x(iBond),iBond=1,jBond)
c================================================
c
            do j=1,jBondGroup-1
               do jBond=1,BondGroup(j,0)
                  i=BondGroup(j,jBond)
                  if(x(i).eq. 1) then
                     vout0(Bonds(1,i))=vout0(Bonds(1,i))+1
                     vin0(Bonds(2,i))= vin0(Bonds(2,i))+1
                  else if (x(i).eq.-1) then
                     vout0(Bonds(2,i))=vout0(Bonds(2,i))+1
                     vin0(Bonds(1,i))= vin0(Bonds(1,i))+1
                  end if
               end do
            end do
c
         end if                 ! End jBond=1 if-block

c ---      1=out-vertex, 2=in-vertex ------------------------------
c
         jBond=BondGroup(jBondGroup,1)
c==========================================================
c$$$                 write(3,*) 'Bond proposed for bond ',jbond
c$$$                 write(3,*) 'Vertices are ',Bonds(1,jBond),
c$$$     >                Bonds(2,jBond)
c$$$                 write(3,*) 'outgoing  bonds at vertex 1:',
c$$$     >                vout0(Bonds(1,jBond)),
c$$$     >                ' max = ',voutMax(Bonds(1,jBond))
c$$$                 write(3,*) 'incoming bonds at vertex 2:',
c$$$     >                vin0(Bonds(2,jBond)),
c$$$     >                ' max = ',vinMax(Bonds(2,jBond))
c=========================================================
         if(vout0(Bonds(1,jBond)).lt.voutMax(Bonds(1,jBond)).and.
     >        vin0(Bonds(2,jBond)).lt.vinMax(Bonds(2,jBond))) then
c
c     The first bond of this group can be added without violating the
c     ice rules.  Add new configuration.
            nc1=nc1+1
            xadd=1
c
            call AddBondC(xadd,jBondGroup)
            if(DEBUG) then
               write(3,*) ' xadd = +1, jBondGroup = ',jBondGroup
               write(3,'("vertex",t10,"vout vin",t25,"voutMax vinMax")')
               do i=1,nVertices
                  if(vout(i).ne.0 .or. vin(i).ne.0) then
                     write(3,'(i4,t11,2i4,t23,2i4)') i, vout(i),vin(i),
     >                    voutMax(i),vinMax(i)
                  end if
               end do
            end if
c
         end if                 ! end if-block to check ice rules
c
c ---      2=out-vertex, 1=in-vertex -----------------------------
c==========================================================
c$$$                 write(3,*) 'Bond proposed for bond ',jbond
c$$$                 write(3,*) 'Vertices are ',Bonds(2,jBond),
c$$$     >                Bonds(1,jBond)
c$$$                 write(3,*) 'outgoing  bonds at vertex 2:',
c$$$     >                vout0(Bonds(2,jBond)),
c$$$     >                ' max = ',voutMax(Bonds(2,jBond))
c$$$                 write(3,*) 'incoming bonds at vertex 1:',
c$$$     >                vin0(Bonds(1,jBond)),
c$$$     >                ' max = ',vinMax(Bonds(1,jBond))
c==========================================================
         if(vout0(Bonds(2,jBond)).lt.voutMax(Bonds(2,jBond)).and.
     >        vin0(Bonds(1,jBond)).lt.vinMax(Bonds(1,jBond))) then
c
c      Add new configuration
c
            nc1=nc1+1
            xadd=-1
            call AddBondC(xadd,jBondGroup)
            if(DEBUG) then
               write(3,*) ' xadd = -1, jBondGroup = ',jBondGroup
               write(3,'("vertex",t11,"vout vin",t23,"voutMax vinMax")')
               do i=1,nVertices
                  if(vout(i).ne.0 .or. vin(i).ne.0) then
                     write(3,'(i4,t10,2i4,t25,2i4)') i, vout(i),vin(i),
     >                    voutMax(i),vinMax(i)
                  end if
               end do
            end if
c     
         end if                 ! end if-block to check ice rules
c
c --- --------------------------------------------------------
c
         end do                 ! End loop over configurations at previous level
      write(3,*) 'Before checking for distinct configs ',nc1,
     >     ' configs enumerated for bond ',jbond
c
      close(1) ! Close file containing bond configs from previous step
      close(2) ! Close file containing new bond configs from which we
               ! must still eliminate symmetry-related configs
c
      return
      end
c
