      subroutine BondOrder
      implicit none
c
      include 'includeSystemSize.f'
      include 'includeGraphEnumeration.f'
c
      logical Assigned(maxBonds)
      integer i,j,iBond,nAB,nInc(maxVertices),nContact,iMax,iVert,
     $     BondsT(2,maxBonds),iFlip0(maxBonds),
     $     jGvT1(maxBonds),jGvT2(maxBonds)
c
      Assigned=.false.
c
c -- BondMap (input: New Bond Index // Output: Old Bond Index)
c -- BondMap2(input: Old Bond Index // Output: New Bond Index)
c
c     nInc counts the number of incident assigned bonds at each vertex.
      nInc=0
c
c --  Assign the first bond
      nAB=1                     ! nAB is the number of assigned bonds
      Assigned(1)=.true.
      BondMap(nAB)=1
      nInc(Bonds(1,1))=1
      nInc(Bonds(2,1))=1
c
c -- Write a temporary warning.
      write(3,*) 'Warning: BondOrder'
      write(3,*) 'This option has not been fully debugged.'
c
c -- Write Vertex Coordination
      if(VERBOSE) write(3,*) '\n Vertex Coordination'
      do while(.true.)
         if(VERBOSE) write(3,'(30(i1,1x))') (nInc(i),i=1,nVertices)
c
c -- Find Vertex with highest coordination that isn't four.
         iVert=0
         iMax=0
         do i=1,nVertices
            if((nInc(i)>iMax).and.(nInc(i).ne.4)) then
               iMax=nInc(i)
               iVert=i
            end if
         end do
c
c -- Independent sub-lattices?
         if(iVert.eq.0) then
            iBond=1
            do while(iBond.le.nBonds)
               if(nInc(iBond).eq.0) then ! Found vertex other sub-lattice
                  iVert=iBond
                  goto 89
               end if
               iBond=iBond+1
            end do
            write(3,*) 'Error: BondOrder'
            write(3,*) 'Unexpected Coordination'
            write(3,'(30(i1,1x))') (nInc(i),i=1,nVertices)
            stop
 89         continue
         end if
c
c -- Loop over all bonds until iVert has coordination of four
         iBond=1
         do while(iBond.le.nBonds)
            if(.not.Assigned(iBond)) then
               if((Bonds(1,iBond).eq.iVert).or.
     $              (Bonds(2,iBond).eq.iVert)) then
                  nInc(Bonds(1,iBond))=nInc(Bonds(1,iBond))+1
                  nInc(Bonds(2,iBond))=nInc(Bonds(2,iBond))+1
                  Assigned(iBond)=.true.
                  nAB=nAB+1
                  BondMap(nAB)=iBond
               end if
            end if
            if(nInc(iVert).eq.4) goto 90
            iBond=iBond+1
         end do
 90      continue               ! Vertex has coordination of four
c     
         if(nAB.eq.nBonds) goto 91
      end do
 91   continue                  ! All Vertices have coordination of four
c
c -- Write BondMap
      if(VERBOSE) then 
         write(3,'(30(i1,1x))') (nInc(i),i=1,nVertices)
         write(3,*) '\n Mapping:'
         write(3,'(30(i2,1x))') (BondMap(i),i=1,nBonds)
      end if
c
c -- Generate the reverse mapping
      do i=1,nBonds
         BondMap2(BondMap(i))=i
      end do
      if(VERBOSE) then
         write(3,*) 'Reverse Mapping:'
         write(3,'(30(i2,1x))') (BondMap2(i),i=1,nBonds)
      end if
c
c -- Reorder Bonds
      if(VERBOSE) write(3,*) '\n The reordered list of H-Bonds'
      do i=1,nBonds
         BondsT(1:2,i)=Bonds(1:2,BondMap(i))
      end do
      Bonds=BondsT
      if(VERBOSE) then
         write(3,*) 'New Index     Old Index'
         do i=1,nBonds
            write(3,*) i,' ',BondMap(i),' ',Bonds(1,i),' ',Bonds(2,i)
         end do
      end if
c
c -- Reorder Invariants
      if(VERBOSE) write(3,*) '\n Reordering Graph Invariants'
      do i=1,nInv
         do j=1,lInv(i)
            Invariants(1,j,i)=BondMap2(Invariants(1,j,i))
            Invariants(2,j,i)=BondMap2(Invariants(2,j,i))
         end do
      end do
c
c -- Reorder Bond Permutations
      if(VERBOSE) write(3,*) '\n Reordering Bond Permutations'
      do i=1,nGv
         do j=1,nBonds
            jGvT1(j)=BondMap2(jGv(j,i))
         end do
         do j=1,nBonds
            jGvT2(j)=jGvT1(BondMap(j))
            iFlip0(j)=iFlip(BondMap(j),i)
         end do
         jGv(1:maxBonds,i)=jGvT2
         iFlip(1:maxBonds,i)=iFlip0
         if(VERBOSE) write(3,'(30(i3,1x))')
     $        iFlip0(1:nBonds)*jGv(1:nBonds,i)
      end do
c
      return
      end
c
         
