      subroutine BondOrderC
      implicit none
c
      include 'includeSystemSize.f'
      include 'includeGraphEnumeration.f'
      include 'includeCoveringCell.f'
c
      logical Assigned(maxBonds),ASSIGNGROUP
      integer i,j,iBond,iGroup,nABG,nB,nInc(maxVertices),nContact,iMax,
     $     iVert,BondsT(2,maxBonds),iFlip0(maxBonds),
     >     BondGroupT(maxBonds,0:maxBonds),
     >     jGvT1(maxBonds),jGvT2(maxBonds), nj,jOld
c
c -- BondMap(input: New Bond Index // Output: Old Bond Index)
c -- BondMap2(input: Old Bond Index // Output: New Bond Index)
c
      if(.not.REORDER) then
         iBond=0
         do j=1,nBondGroup
            BondGroupMap(j)=j
            do i=1,BondGroup(j,0)
               iBond=iBond+1
               BondMap(iBond)=BondGroup(j,i)
            end do
         end do
         go to 100
      end if
c
      Assigned=.false.
c
c -- nInc counts the number of incident assigned bonds at each vertex.
      nInc=0
c
c -- Assign the first bond
      nABG=1                    ! nABG is the number of assigned bond groups
      nB=0
      Assigned(1)=.true.
      BondGroupMap(nABG)=1
      do i=1,BondGroup(1,0)     ! Loop over bonds in first group
         nB=nB+1
         iBond=BondGroup(1,i)
         BondMap(nB)=iBond
         nInc(Bonds(1,iBond))=nInc(Bonds(1,iBond))+1
         nInc(Bonds(2,iBond))=nInc(Bonds(2,iBond))+1
      end do
c
c -- Write a temporary warning.
      write(3,*) 'Warning: BondOrderC'
      write(3,*) 'This option has not been fully debugged.'
c
c -- Write Vertex Coordination
      if(VERBOSE) write(3,*) ' Vertex Coordination'
      do while(.true.)
         if(VERBOSE) write(3,'(30(i1,1x))') (nInc(i),i=1,nVertices)
c
c -- Find Vertex with highest coordination that isn't four.
         iVert=0
         iMax=0
         do i=1,nVertices
            if((nInc(i)>iMax).and.(nInc(i).ne.4)) then
               iMax=nInc(i)
               iVert=i
            end if
         end do
c
c -- Independent sub-lattices?
         if(iVert.eq.0) then
            i=1
            do while(i.le.nBonds)
               if(nInc(i).eq.0) then
                  iVert=i
                  goto 89
               end if
               i=i+1
            end do
            write(3,*) 'Error: BondOrderC'
            write(3,*) 'Unexpected Coordination'
            write(3,'(30(i1,1x))') (nInc(i),i=1,nVertices)
            stop
 89         continue
         end if
c
         if(VERBOSE) then
            write(3,*) '# of Groups assigned: ',nABG
            write(3,*) 'Vertex with largest coordination: ',iVert
         end if
c
c -- Loop over all bonds & groups until iVert has coordination of four
         iGroup=1
         do while(iGroup.le.nBondGroup)
            if(.not.Assigned(iGroup)) then ! Skip groups already assigned
               ASSIGNGROUP=.false.
               do i=1,BondGroup(iGroup,0)
                  iBond=BondGroup(iGroup,i)
                  if((Bonds(1,iBond).eq.iVert).or.
     $                 (Bonds(2,iBond).eq.iVert)) ASSIGNGROUP=.true.
               end do
               if(ASSIGNGROUP) then
                  nABG=nABG+1
                  BondGroupMap(nABG)=iGroup
                  do i=1,BondGroup(iGroup,0)
                     Assigned(iGroup)=.true.
                     iBond=BondGroup(iGroup,i)
                     nInc(Bonds(1,iBond))=nInc(Bonds(1,iBond))+1
                     nInc(Bonds(2,iBond))=nInc(Bonds(2,iBond))+1
                     nB=nB+1
                     BondMap(nB)=iBond
                  end do
               end if
            end if
            if(nInc(iVert).eq.4) goto 90
            iGroup=iGroup+1
         end do
 90      continue
c     
         if(nB.eq.nBonds) goto 91
      end do
 91   continue                  ! All Vertices have coordination of four
      if(VERBOSE) write(3,'(30(i1,1x))') (nInc(i),i=1,nVertices)
c
 100  continue
c -- Write BondMap
      if(VERBOSE) then 
         write(3,*) 'Bond Mapping:'
         write(3,'(30(i3,1x))') (BondMap(i),i=1,nBonds)
         write(3,*) 'Bond Group Mapping:'
         write(3,'(30(i2,1x))') (BondGroupMap(i),i=1,nBondGroup)
      end if
c
c -- Generate the reverse mappings
      do i=1,nBonds
         BondMap2(BondMap(i))=i
      end do
c
      do j=1,nBondGroup
         BondGroupMap2(BondGroupMap(j))=j
      end do
c
      if(VERBOSE) then
         write(3,*) 'Reverse Bond Mapping:'
         write(3,'(30(i3,1x))') (BondMap2(i),i=1,nBonds)
         write(3,*) 'Reverse Bond Group Mapping:'
         write(3,'(30(i2,1x))') (BondGroupMap2(i),i=1,nBondGroup)
      end if
c
c -- Reorder Bonds
      if(VERBOSE) write(3,*) 'The reordered list of H-Bonds'
      do i=1,nBonds
         BondsT(1:2,i)=Bonds(1:2,BondMap(i))
      end do
      Bonds=BondsT
      if(VERBOSE) then
         write(3,*) ' Reordered Bonds'
         write(3,*) 'New Index     Old Index'
         do i=1,nBonds
            write(3,*) i,' ',BondMap(i),' ',Bonds(1,i),' ',Bonds(2,i)
         end do
      end if
c
c -- Reorder Bond Groups
c
      do j=1,nBondGroup
         nj=BondGroup(BondGroupMap(j),0)
         BondGroupT(j,0)=BondGroup(BondGroupMap(j),0)
         do i=1,nj
            jOld=BondGroupMap(j)
            BondGroupT(j,i)=BondMap2( BondGroup(jOld,i) )
         end do
      end do
      BondGroup=BondGroupT
      if(VERBOSE) then
         write(3,*) ' Reordered Bond Groups'
         write(3,*) 'New Index     Old Index'
         do j=1,nBondGroup
            write(3,*) j,' ',BondGroupMap(j)
         end do
c
         write(3,*) ' new BondGroup array'
         do j=1,nBondGroup
            write(3,*) ' bond group ',j
            write(3,'(15(1x,i3))') (BondGroup(j,i),i=1,BondGroup(j,0))
         end do
      end if
c
c -- Reorder Invariants
      if(VERBOSE) write(3,*) ' Reordering Graph Invariants'
      do i=1,nInv
         do j=1,lInv(i)
            Invariants(1,j,i)=BondMap2(Invariants(1,j,i))
            Invariants(2,j,i)=BondMap2(Invariants(2,j,i))
         end do
      end do
c
c -- Reorder Bond Permutations
      if(VERBOSE) write(3,*) ' Reordering Bond Permutations'
      do i=1,nGv
         do j=1,nBonds
            jGvT1(j)=BondMap2(jGv(j,i))
         end do
         do j=1,nBonds
            jGvT2(j)=jGvT1(BondMap(j))
            iFlip0(j)=iFlip(BondMap(j),i)
         end do
         jGv(1:maxBonds,i)=jGvT2
         iFlip(1:maxBonds,i)=iFlip0
         if(VERBOSE) write(3,'(30(i4,1x))')
     $        iFlip0(1:nBonds)*jGv(1:nBonds,i)
      end do
c
      return
      end
c
         
