      subroutine Deal(jBond,nc1)
      implicit none
c
      include 'includeSystemSize.f'
      include 'includeGraphEnumeration.f'
c
      integer :: jBond,nc1, i,j,j1, k,k1,l,m,m1, b1,b2, jSort,
     >     Unit,nSortFiles1, ic1, nRead,nWriteTotal,
     >     nWrite1(maxSortFiles),status
      character*200 SortFileList1(maxSortFiles)
c
      integer :: nSortFiles2,nWrite2(maxSortFiles) ! Chris
      character*200 SortFileList2(maxSortFiles) ! Chris
c
c     Except for the first invariant for sorting, nSortFiles1 is the
c     number of active sort files from the previous round of dealing
c     going into the next round, and nSortFiles is the running count of
c     sort files of the current round.
      nSortFiles1=0
c
c     nSortFiles2 is the number of finished sort files, that is, in
c     which the number of configurations is less than
c     InvariantThreshold.
      nSortFiles2=0
c
      nWriteTotal=0
c
c     Initialize buffer populations
c
c --- --------------- zero buffer count ------------------------Buffer
      do k=1,maxInvValues
         xBufferPop(k)=0
      end do
c --- ----------------------------------------------------------Buffer
c
c     Deal configs according to 1st invariant after calculating values
c     for all active invariants.  Store configs and all invariant
c     values.  This routine expects a file open on unit 2.
      nRead=0
      do ic1=1,nc1
c
c -- Bond variables for all bonds, including empty bonds
         read(2) (x(k),k=1,jBond)
         nRead=nRead+1
         if(jBond<nBonds) then
            do k=jBond+1,nBonds
               x(k)=0
            end do
         end if
c
c -- Diagonal bond products
         do b1=1,nBonds
            BondProduct(b1,b1)=x(b1)*x(b1)
         end do
c
c -- Off-diagonal bond products
         do b1=2,nBonds
            do b2=1,b1-1
               BondProduct(b1,b2)=x(b1)*x(b2)
               BondProduct(b2,b1)=BondProduct(b1,b2)
            end do
         end do
c
c -- Calculate invariants
         do j=1,nBestActiveInv
            i=BestActiveInvList(j)
            InvValues(j)=0
            do k=1,lInv(i)
               InvValues(j)=InvValues(j)+BondProduct(
     >              Invariants(1,k,i),Invariants(2,k,i))*
     >              Invariants(3,k,i)
            end do              ! end loop over terms in invariant
         end do                 ! end loop over best active invariants
c
c     Accumulate statistics on invariants

c     nInvValue(j) contains the number of distinct values taken by
c     invariant j over the whole set of configs.

c     InvSortValues(j) reflects the properties of the currently read
c     config, i.e. 3rd value of invariant 1, 1st value of invariant 2,
c     etc.  This is the information that gets written along with the
c     configs in the intermediate "XX..." files.
c
c -- Some initialization if this is the first config
         if(ic1.eq.1) then      ! First config, value index = 1
            do j=1,nBestActiveInv
               InvValuePop(1,j)=1
               InvValueList(1,j)=InvValues(j)
               InvSortValues(j)=1
               nInvValue(j)=1
            end do
            nSortFiles1=nSortFiles1+1
            SortFileList1(nSortFiles1)='XX'//ext(InvSortValues(1))
            Unit=10+nSortFiles1
            open(unit=Unit,file=SortFileList1(nSortFiles1),
     >           form='unformatted')
            nWrite1(nSortFiles1)=0
         else                   ! after first config
c     Either identify position of invariant value on list...
            do j=1,nBestActiveInv
               do k=1,nInvValue(j)
                  if(InvValues(j).eq.InvValueList(k,j)) then
c            invariant value detected in previous config
                     InvValuePop(k,j)=InvValuePop(k,j)+1
                     InvSortValues(j)=k
                     go to 20
                  end if
               end do           ! end loop over previous values of
                                ! active invariant j
c     ...or add new list value for jth active invariant
               if(nInvValue(j).eq.maxInvValues) then
                  write(3,*)
     >                 'Number of values taken by active invariant ',j
     >                 ,' exceeds maxInvValues.  Program halted.'
                  stop
               end if
               nInvValue(j)=nInvValue(j)+1
               InvValueList(nInvValue(j),j)=InvValues(j)
               InvValuePop(nInvValue(j),j)=1
               InvSortValues(j)=nInvValue(j)
               if(j.eq.1) then
                  nSortFiles1=nSortFiles1+1
                  SortFileList1(nSortFiles1)='XX'//ext(InvSortValues(1))
                  Unit=10+nSortFiles1
                  open(unit=Unit,file=SortFileList1(nSortFiles1), form
     >                 ='unformatted')
                  nWrite1(nSortFiles1)=0
               end if
 20            continue
            end do              ! end loop over active invariants
         end if                 ! end if-block for first config
c
c     Write config ic1 and all invariant sort indices into several files
c     according to the sort index of first active invariant
         m=InvSortValues(1)
c$$$         Unit=10+m
c$$$         write(Unit) (x(k),k=1,jBond)
c$$$         write(Unit) (InvSortValues(k),k=1,nBestActiveInv)
c
c --- ------ write to buffer until full ---- -------------------Buffer
c
         xBufferPop(m)=xBufferPop(m)+1
         do k=1,jBond
            xBuffer(k,xBufferPop(m),m)=x(k)
         end do
         do k=1,nBestActiveInv
            InvSortValBuff(k,xBufferPop(m),m)=InvSortValues(k)
         end do
c
c     flush buffer if full
         if(xBufferPop(m).eq.nxBuffer) then
            Unit=10+m
            do j1=1,nxBuffer
               write(Unit) (xBuffer(k,j1,m),k=1,jBond)
               write(Unit) (InvSortValBuff(k,j1,m),
     >              k=1,nBestActiveInv)
            end do
            xBufferPop(m)=0
         end if
c
c --- ----------------------------------------------------------Buffer
         nWrite1(m)=nWrite1(m)+1
         nWriteTotal=nWriteTotal+1
c
      end do                    ! end ic1 loop over configs
      close(2)
c
c -- Empty buffers, close files and write some stats
      do i=1,nSortFiles1
         Unit=10+i
c --- ------ flush buffers before closing files ----------------Buffer
         if(xBufferPop(i).gt.0) then
            do j1=1,xBufferPop(i)
               write(Unit) (xBuffer(k,j1,i),k=1,jBond)
               write(Unit) (InvSortValBuff(k,j1,i),
     >              k=1,nBestActiveInv)
            end do
         end if
c --- ----------------------------------------------------------Buffer
         close(Unit)
         l=len_trim(SortFileList1(i))
         if(DEBUG) write(3,*) nWrite1(i),' configs written to ',
     >        SortFileList1(i)(1:l)
      end do
c
      write(3,'(i11," configs read at sorting level ",i3)') nRead,1
      write(3,'(i8," configs written at sorting level ",i3,/)')
     >     nWriteTotal,1
c
c
c
c
c
c     Going into each sort level, the number of previous files is
c     nSortFiles1 and their names are in SortFileList1.  The number of
c     files generated at the current sort level will be nSortFiles and
c     their names stored in SortFileList.
      do jSort=2,nBestActiveInv
         nSortFiles=0
         nRead=0
         nWriteTotal=0
c
         do j=1,nSortFiles1     ! loop over previously generated files
c     Open file for read
            if(nWrite1(j).eq.0) go to 18
c
c     The following block "finishes" files containing a number of
c     configs that are below InvariantThreshold.
            if((nWrite1(j).le.InvariantThreshold)) then         ! Chris
               nSortFiles2=nSortFiles2+1                        ! Chris
               nWrite2(nSortFiles2)=nWrite1(j)                  ! Chris
               SortFileList2(nSortFiles2)=SortFileList1(j)      ! Chris
               nRead=nRead+nWrite1(j)                           ! Chris
               nWriteTotal=nWriteTotal+nWrite1(j)               ! Chris
c
c       remove invariants from file
               l=len_trim(SortFileList1(j))                     ! Chris
               call system('rm -f Temp')! Chris
               open(unit=8,file=SortFileList1(j)(1:l),form      ! Chris
     >              ='unformatted')
               open(unit=9,file='Temp',form='unformatted')      ! Chris
c
               do while(.true.)
                  read(8,end=33) (x(k),k=1,jBond)               ! Chris
                  read(8) (InvSortValues(k),k=1,nBestActiveInv) ! Chris
                  write(9) (x(k),k=1,jBond)                     ! Chris
               end do
 33            continue                                         ! Chris
               close(8)                                         ! Chris
               close(9)                                         ! Chris
               call system('mv Temp '//SortFileList1(j)(1:l))   ! Chris
c
               if(DEBUG) write(3,*) 'skipped ',SortFileList1(j)(1:l) ! Chris
               goto 30
            end if
c
c     If this code is reached, the number of configs in the file is
c     still above InvariantThreshold and further sorting is done.
c
c     Open files for read
            open(unit=2,file=SortFileList1(j),form='unformatted')
c
c --- --------------- zero buffer count ------------------------Buffer
            do k=1,maxInvValues
               xBufferPop(k)=0
            end do
c --- ----------------------------------------------------------Buffer
c
c     Open files for write
            do k=1,nInvValue(jSort)
               nSortFiles=nSortFiles+1
               if(nSortFiles>maxSortFiles) then
                  write(3,*)
     >                 ' Number of sort files exceeds maxSortFiles.'
                  write(3,*) ' nSortFiles: ',nSortFiles
                  write(3,*) ' maxSortFiles: ',maxSortFiles
                  write(3,*) ' Program halted.'
                  stop
               end if
c
               l=len_trim(SortFileList1(j))
               SortFileList(nSortFiles)=SortFileList1(j)(1:l)//
     >              ext(k)
               Unit=k+10
               open(unit=Unit,file=SortFileList(nSortFiles),form
     >              ='unformatted')
               nWrite(nSortFiles)=0
               l=len_trim(SortFileList(nSortFiles))
               if(DEBUG) write(3,*) 'open ',
     $              SortFileList(nSortFiles)(1:l)
            end do              ! end k-loop over nInvValue(jSort) files
                                ! for writing
c     Read and sort configs from SortFileList1(j)
 10         read(2,end=15) (x(k),k=1,jBond)
            read(2) (InvSortValues(k),k=1,nBestActiveInv)
            nRead=nRead+1
            m=InvSortValues(jSort)
            m1=nSortFiles-nInvValue(jSort)+m
c$$$            Unit=10+m
c$$$            write(Unit) (x(k),k=1,jBond)
c$$$            if(jSort<nBestActiveInv)  write(Unit) (InvSortValues(k),k=1
c$$$     >           ,nBestActiveInv)
c --- ------ write to buffer until full ---- -------------------Buffer
c
         xBufferPop(m)=xBufferPop(m)+1
         do k=1,jBond
            xBuffer(k,xBufferPop(m),m)=x(k)
         end do
         if(jSort<nBestActiveInv) then
            do k=1,nBestActiveInv
               InvSortValBuff(k,xBufferPop(m),m)=InvSortValues(k)
            end do
         end if
c
c     flush buffer if full
         if(xBufferPop(m).eq.nxBuffer) then
            Unit=10+m
            if(jSort<nBestActiveInv) then
               do j1=1,nxBuffer
                  write(Unit) (xBuffer(k,j1,m),k=1,jBond)
                  write(Unit) (InvSortValBuff(k,j1,m),
     >                 k=1,nBestActiveInv)
               end do
            else
               do j1=1,nxBuffer
                  write(Unit) (xBuffer(k,j1,m),k=1,jBond)
               end do
            end if
            xBufferPop(m)=0
         end if
c
c --- ----------------------------------------------------------Buffer
            nWrite(m1)=nWrite(m1)+1
            nWriteTotal=nWriteTotal+1
            go to 10
c
 15         continue            ! Finished sorting SortFileList1(j)
c     Close all open files
            close(2)
            do k=1,nInvValue(jSort)
               Unit=k+10
c --- ------ flush buffers before closing files ----------------Buffer
               if(xBufferPop(k).gt.0) then
                  if(jSort<nBestActiveInv) then
                     do j1=1,xBufferPop(k)
                        write(Unit) (xBuffer(k1,j1,k),k1=1,jBond)
                        write(Unit) (InvSortValBuff(k1,j1,k),
     >                       k1=1,nBestActiveInv)
                     end do
                  else
                     do j1=1,xBufferPop(k)
                        write(Unit) (xBuffer(k1,j1,k),k1=1,jBond)
                     end do
                  end if
               end if
c --- ----------------------------------------------------------Buffer
               close(Unit)
               m1=nSortFiles -nInvValue(jSort)+k
               l=len_trim(SortFileList(k))
               if(DEBUG) write(3,*) nWrite(m1),' configs written to ',
     >              SortFileList(m1)(1:l)
            end do
 18         continue
            write(3,*) ' XX file with zero length detected'
            write(3,*) '   file name is ',SortFileList1(j),
     >           ' at bond ',jbond
            call system('rm '//SortFileList1(j))
 30         continue                                    ! Chris
         end do                 ! end j loop over previously written
                                ! files
c
         if(nSortFiles.eq.0) goto 31                    ! Chris
c
         if(jSort<nBestActiveInv) then
c     Chris wrote: Isn't this always true, since we're inside a do loop?
c     Sherwin answer: I'm not sure if anything would break if we didn't
c     perform this test, but that if statement detects if you are on the
c     last possible invariant used for sorting.  If jSort =
c     nBestActiveInv, then these statements are skipped.
            nSortFiles1=nSortFiles
            do j=1,nSortFiles
               SortFileList1(j)=SortFileList(j)
               nWrite1(j)=nWrite(j)
            end do
         end if
         write(3,'(i11," configs read at sorting level ",i3)') nRead
     >        ,jSort
         write(3,'(i8," configs written at sorting level ",i3,/)')
     >        nWriteTotal,jSort
      end do                    ! End jSort loop over active invariants
                                ! for sorting
 31   continue                                          ! Chris
c
c -- Generate complete list of files for symmetry comparison
      if(nSortFiles2.gt.0) then                         ! Chris
         do j=1,nSortFiles2                             ! Chris
            SortFileList(nSortFiles+j)=SortFileList2(j) ! Chris
            nWrite(nSortFiles+j)=nWrite2(j)             ! Chris
         end do                                         ! Chris
         nSortFiles=nSortFiles+nSortFiles2              ! Chris
      end if                                            ! Chris
c
      write(3,'(/,i9," configs sorted into ",i5," files")') nc1,
     $     nSortFiles
      write(3,*) '          file      configs      file name'
      do j=1,nSortFiles
         l=len_trim(SortFileList(j))
         write(3,*) j,nWrite(j),'  ',SortFileList(j)(1:l)
      end do
c
      return
      end

