      implicit none
c
      include 'includeSystemSize.f'
      include 'includeGraphEnumeration.f'
c
      integer :: i,j,k, jBond, nc,nc1, nRead,nDistinct
      real :: time1, time2,ttime1,ttime2
      logical UseInvariants
c
c --- Initialize some arrays
      call NullString(BaseFolder)
      call NullString(FileName)
c
c --- Input (eventually will come from an input file)
c
c      BaseFolder='/home/singer/singer/Projects/H2O/OrientedGraph'//
c     >     '/PeriodicInvariants/Results/IceI/IceIh2x1x1-newcode/'
      BaseFolder='/home/singer/singer/Projects/H2O/OrientedGraph'//
     >     '/PeriodicInvariants/Results/IceV1x1x1/'
      nInvForDeal=5
c
      UseInvariants=.true.
c
c --- Read input files
c
      call IOFiles
c
      call ReadBonds
c
      call ReadGv
c
c      call BondOrbits
c      call BondOrder
c
      call ReadModel
c
      if(UseInvariants) then
         call ReadInvariants
         call LoadExt
      end if
c
c --- Generate bond permutation group
c
      call BondPerm
c
c ---      Initialize graph enumeration polynomial ------
c
      nc=1
      do i=1,nBonds
         x(i)=0
         x1(i)=0
      end do
c
      call BondPerm
c
c ---      Initialize graph enumeration polynomial ------
c
      nc=1
      do i=1,nBonds
         x(i)=0
         x1(i)=0
      end do
c
      do i=1,nVertices
         vin(i)=0
         vout(i)=0
         vin0(i)=0
         vout0(i)=0
      end do
c
      call cpu_time(time1)
      write(3,'("CPU time: ",f20.7," setup")') time1
c --- Loop over bonds -------------------------------------------
c
      do jBond=1,nBonds
         call cpu_time(ttime1)
c
         write(3,'(10(1h-),t12,i5,t20,10(1h-))') jBond
         write(3,*) nc,' configurations from previous bond'
c
c     Read bond configs filled up to bond jbond-1 from unit 1
c     Write new bond configs filled up to bond jbond but without
c     symmetry testing to unit 2.
         if(jBond>1) open(unit=1,file='XFile',form='unformatted')
         open(unit=2,file='XFile1',form='unformatted')
         call AddBonds(jBond,nc,nc1)
         call cpu_time(time2)
         write(3,'("CPU time: ",f20.7," add bonds at bond ",i3)')
     >       (time2-time1),jbond
         time1=time2
c
         if(nc1>InvariantThreshold.and.UseInvariants) then
            open(unit=2,file='XFile1',form='unformatted')
            call InvariantSample(jBond,nc1)
            call cpu_time(time2)
            write(3,
     >           '("CPU time: ",f20.7," invariant sample at bond ",i3)')
     >           (time2-time1),jbond
            time1=time2
c
            open(unit=2,file='XFile1',form='unformatted')
            call Deal(jBond,nc1)
            call system('rm XFile1')
            write(3,'("CPU time: ",f20.7," deal configs at bond ",i3)')
     >           (time2-time1),jbond
            time1=time2
cc
            open(unit=2,file='XFile',form='unformatted')
            nc=0
            nc1=0
            do j=1,nSortFiles
               if(nWrite(j)>0) then
                  open(unit=1,file=SortFileList(j),form='unformatted')
                  call SymSearch(jBond,nRead,nDistinct)
                  nc1=nc1+nRead
                  nc=nc+nDistinct
               end if
                  call system('rm '//SortFileList(j))
            end do
            close(2)
            write(3,
     >           '("CPU time: ",f20.7," symmetry search at bond ",i3)')
     >           (time2-time1),jbond
            time1=time2
c
         else
c
c     Read a block of nc1 bond configs from unit 1, eliminate
c     symmetry-related configs, and write the nc symmetry-distinct
c     configs to unit 2.
            open(unit=1,file='XFile1',form='unformatted')
            open(unit=2,file='XFile',form='unformatted')
            call SymSearch(jBond,nc1,nc)
            close(2)
            write(3,'("CPU time: ",f20.7
     >         ," symmetry search w/o invariants at bond ",i3)')
     >           (time2-time1),jbond
            time1=time2
         end if
c
         write(3,'("Bond ",i3,": ",i8," ->",i8
     >," by elimination of symmetry-related configs.")') jBond,nc1,nc
c
         call cpu_time(ttime2)
         write(3,'("total CPU time: ",f20.7 ," bond ",i3)')
     >        (ttime2-ttime1),jBond
      end do                    ! End j-bond loop
c
c ---      --------------------------------------------------------
c$$$      equivalence (xBuffer,xBuff1)
c$$$c
c$$$      integer k,j
c$$$      integer(kind=1) ib(0:maxBonds)
c$$$c
c$$$c --- Derived parameters
c$$$      nWriteByte=nBonds/8
c$$$      nWriteByte=nWriteByte+1
c$$$c
c$$$c --- Write bonds to file
c$$$c
c$$$c
c$$$c --- Read bonds from file
c$$$c
c$$$      do k=1,BufferBytes
c$$$         xBuff1(k)=0
c$$$      end do
c$$$      xBuff1(1)=int(127,1)
c$$$      xBuff1(3)=int(127,1)
c$$$c
c$$$      do j=0,maxBonds-1
c$$$         ib(j)=iBits(xBuffer,j,1)
c$$$      end do
c$$$      write(*,'(1x,32i1)') (ib(maxBonds-j),j=1,maxBonds)
c$$$c
c
      stop
      end

