      implicit none
c
      include 'includeSystemSize.f'
      include 'includeGraphEnumeration.f'
      include 'includeCoveringCell.f'
c
      integer :: i,j,k, jBond,jBondGroup,iBondGroup,jBondGroupStart,
     >     nc,nc1, nRead,nDistinct,nj
      real :: time1, time2,ttime1,ttime2
      character*3  rd
      character*10 str                                      ! Chris
c
      real :: etime,elapsed(2),total
c
c --- Initialize some arrays
      call NullString(BaseFolder)
      call NullString(FileName)
c
c --- Input (eventually will come from an input file)
c
c      BaseFolder='/home/singer/singer/Projects/H2O/OrientedGraph'//
c     >     '/PeriodicInvariants/Results/IceI/IceIh2x1x1-newcode/'
c      BaseFolder='/home/singer/singer/Projects/H2O/OrientedGraph'//
c     >     '/PeriodicInvariants/Results/IceV1x1x1/'
c      BaseFolder='/home/singer/cknight/Ice/Graph_Code/ice/'
      BaseFolder='./'
c
      call IOFiles
      call ReadInput
c
c$$$      nInvForDeal=6
c$$$c
c$$$      UseInvariants=.true.
c$$$      DEBUG=.false.
c
c --- Read input files
      call ReadBonds
c
      call ReadBondsC
c
      call ReadGv
c
      call ReadModel
c
      if(UseInvariants) then
         call ReadInvariants
         call LoadExt
      end if
c
c --- Generate bond permutation group
      call BondPerm
c
c -- Reorder H-Bonds
c
      call BondOrderC
c
c ---      Initialize graph enumeration polynomial ------
      nc=1
      x=0
      x1=0
c
      vin=0
      vout=0
      vin0=0
      vout0=0
c
      call cpu_time(time1)
      write(3,*)'\n Initialization Completed'
      write(3,'("CPU time: ",f20.7," setup")') time1
      total=etime(elapsed)
c$$$      write(3,*) 'User: ',elapsed(1),' System: ',elapsed(2),' Total: ',
c$$$     $     total
c$$$      stop
      jBondGroupStart=1
c
c -- Open restart file(denoted by bond index, not group index)
      inquire(file='RESTART',read=rd)
      if(rd.eq.'YES') then
         open(unit=1,file='RESTART')
         read(1,*) nj! jBondGroupStart
         close(1)
c     
         write(str,'(i10)') nj! jBondGroupStart
         call system('cp XFile.'//trim(adjustl(str))//'.rst XFile')
         open(unit=1,file='XFile',form='unformatted')
         nc=0
         do while(.true.)
            read(1,end=99) (x(i),i=1,nj)! jBondGroupStart)
            nc=nc+1
         end do
 99      continue
         close(1)
c
         k=0                    ! Find Group index
         jBond=0
         do while(.true.)
            k=k+1
            jBond=jBond+BondGroup(k,0)
            if(jBond.eq.nj) goto 98
         end do
 98      continue
         jBondGroupStart=k+1
c
         write(3,*) 'Restarting Enumeration from Bond Group: ',
     >        jBondGroupStart
         write(3,*) 'Restarting Enumeration from Bond :      ',nj+1
      end if
c
c --- Loop over bonds -------------------------------------------
      do jBondGroup=jBondGroupStart,nBondGroup
c
         call cpu_time(ttime1)
c
         write(3,*)
         write(3,'(10(1h-)," Bond Group ",t25,i5,t32,10(1h-))')
     >        jBondGroup
         write(3,*) nc,' configurations from previous bond'
c
c     Read bond configs filled up to bond group jbondgroup-1 from unit
c     1.  Write new bond configs filled up to bond group jbondgroup but
c     without symmetry testing to unit 2.
         if(jBondGroup>1) open(unit=1,file='XFile',form='unformatted')
         open(unit=2,file='XFile1',form='unformatted')
         call AddBondsC(jBondGroup,nc,nc1)
         nj=BondGroup(jBondGroup,0)
         jBond=BondGroup(jBondGroup,nj)
c
         call cpu_time(time2)
         write(3,'("CPU time: ",f20.7," add bonds at bond ",i3)')
     >        (time2-time1),jbond
         time1=time2
c     
         if(nc1>InvariantThreshold.and.UseInvariants) then
            open(unit=2,file='XFile1',form='unformatted')
            call InvariantSample(jBond,nc1)
c     
            call cpu_time(time2)
            write(3,
     >           '("CPU time: ",f20.7," invariant sample at bond ",i3)')
     >           (time2-time1),jbond
            time1=time2
c     
            open(unit=2,file='XFile1',form='unformatted')
            call Deal(jBond,nc1)
            call system('rm XFile1')
c     
            call cpu_time(time2)
            write(3,'("CPU time: ",f20.7," deal configs at bond ",i3)')
     >           (time2-time1),jbond
            time1=time2
c     
            open(unit=2,file='XFile',form='unformatted')
            nc=0
            nc1=0
            do j=1,nSortFiles
c
c -- Soft Exit?
               inquire(file='EXIT',read=rd)
               if(rd.eq.'YES') then 
                  write(3,*) 'Soft EXIT requested'
                  call system('rm EXIT')
                  stop
               end if
c
               if(nWrite(j)>0) then
                  open(unit=1,file=SortFileList(j),form='unformatted')
                  call SymSearch(jBond,nRead,nDistinct)
                  nc1=nc1+nRead
                  nc=nc+nDistinct
               end if
               call system('rm '//SortFileList(j))
            end do
            close(2)
            call cpu_time(time2)
            write(3,
     >           '("CPU time: ",f20.7," symmetry search at bond ",i3)')
     >           (time2-time1),jbond
            time1=time2
         else
c     
c     Read a block of nc1 bond configs from unit 1, eliminate
c     symmetry-related configs, and write the nc symmetry-distinct
c     configs to unit 2.
            open(unit=1,file='XFile1',form='unformatted')
            open(unit=2,file='XFile', form='unformatted')
            call SymSearch(jBond,nc1,nc)
            close(2)
c     
            call cpu_time(time2)
            write(3,'("CPU time: ",f20.7
     >           ," symmetry search w/o invariants at bond ",i3)')
     >           (time2-time1),jbond
            time1=time2
         end if
c     
         write(3,'("Bond ",i3,": ",i8," ->",i8
     >        ," by elimination of symmetry-related configs.")') jBond,
     $        nc1,nc
c     
         call cpu_time(ttime2)
         write(3,'("total CPU time: ",f20.7 ," bond ",i3)')
     >        (ttime2-ttime1),jBond
c     
c -- Write restart file
         write(str,'(i10)') jbond ! Chris
         call system('cp XFile XFile.'//trim(adjustl(str))//'.rst') ! Chris
c
c -- Soft Exit?
         inquire(file='EXIT',read=rd)
         if(rd.eq.'YES') then 
            write(3,*) 'Soft EXIT requested'
            call system('rm EXIT')
            stop
         end if
      end do                    ! End j-bond loop
c     
c ---      --------------------------------------------------------
c$$$      equivalence (xBuffer,xBuff1)
c$$$c
c$$$      integer k,j
c$$$      integer(kind=1) ib(0:maxBonds)
c$$$c
c$$$c --- Derived parameters
c$$$      nWriteByte=nBonds/8
c$$$      nWriteByte=nWriteByte+1
c$$$c
c$$$c --- Write bonds to file
c$$$c
c$$$c
c$$$c --- Read bonds from file
c$$$c
c$$$      do k=1,BufferBytes
c$$$         xBuff1(k)=0
c$$$      end do
c$$$      xBuff1(1)=int(127,1)
c$$$      xBuff1(3)=int(127,1)
c$$$c
c$$$      do j=0,maxBonds-1
c$$$         ib(j)=iBits(xBuffer,j,1)
c$$$      end do
c$$$      write(*,'(1x,32i1)') (ib(maxBonds-j),j=1,maxBonds)
c$$$c
c                                                                 ! Chris
c -- Write configurations as plain ASCII                          ! Chris
      call system('mv XFile XFile1')                              ! Chris
      open(unit=1,file='XFile1',form='unformatted')               ! Chris
      open(unit=2,file='XFile',form='formatted',status="REPLACE") ! Chris
      write(str,'(i10)') nBonds                                   ! Chris
      do i=1,nc                                                   ! Chris
         read(1,end=15) (x(j),j=1,nBonds)                         ! Chris
         if(REORDER) then                                         ! Chris
            write(2,'('//trim(adjustl(str))//'(1x,i2))')          ! Chris
     $           (x(BondMap2(j)),j=1,nBonds)                      ! Chris
         else                                                     ! Chris
            write(2,'('//trim(adjustl(str))//'(1x,i2))')          ! Chris
     $           (x(j),j=1,nBonds)                                ! Chris
         end if                                                   ! Chris
      end do                                                      ! Chris
 15   continue                                                    ! Chris
      close(1)                                                    ! Chris
      close(2)                                                    ! Chris
      call system('rm XFile1')
c
      stop
      end

