      subroutine ReadInvariants
      implicit none
c
      include 'includeSystemSize.f'
      include 'includeGraphEnumeration.f'
c
      integer i,j,k,nTerms, ioss,lBaseFolder, nInv0
      character*3 rd
c
      lBaseFolder=len_trim(BaseFolder)
c
      FileName=BaseFolder(1:lBaseFolder)//'Invar'
c
      inquire(file=trim(FileName),read=rd)
      if(rd.eq.'NO') then
         write(*,*) 'Error: ReadInvariants'
         write(*,*) 'Input File Not Readable: ',trim(FileName)
         stop
      end if
c
      open(unit=1,file=FileName)
      read(1,*) nInv0
      nInv=0
      do j=1,maxInvariants+1
         read(1,*,iostat=ioss,end=11) nTerms
         if(j>maxInvariants) go to 21
         if(nTerms>maxGroupOrder)  go to 31
         lInv(j)=nTerms
         nInv=nInv+1
         do i=1,nTerms
            read(1,*) (Invariants(k,i,j),k=1,3)
         end do
      end do
 21   write(*,*) 'Invariants array dimensioned for too few invariants.'
      stop
 31   write(*,*) 'Invariants array dimensioned for too few bonds.'
      stop
 11   close(1)
c
      if(nInv.ne.nInv0) write(*,*)
     >     'WARNING: Number of invariants does not match number ',
     >     'declared at head of ',FileName
      if(VERBOSE) then
         write(3,'(i5," invariants read",/,t2,"inv",t11,"bonds",t20,
     >        "coef")') nInv
         do j=1,nInv
            do i=1,lInv(j)
               write(3,'(i4,t8,2i4,t20,i3)') j,(Invariants(k,i,j),k=1,3)
            end do
         end do
         write(3,'(//)')
      end if
c
      return
      end
