      subroutine SymSearch(jBond,nc1,nc)
      implicit none
c
      include 'includeSystemSize.f'
      include 'includeGraphEnumeration.f'
c
      integer :: jBond,nc,nc1, iGv, ic1,jc1, j
c
c     This routine expects to read nc1 bond configs from unit 1.  It
c     will eliminate symmetry-related configurations and write the nc
c     symmetry-distinct configurations to unit 2.
c
c     Read nc1 configurations from XFile1
      nc1=0
 10   continue
      read(1,end=15) (x(j),j=1,jBond)
c$$$      write(3,*) ' SymSearch read ',(x(j),j=1,jBond)
      nc1=nc1+1
      do j=1,jBond
         xx(j,nc1)=x(j)
      end do
      go to 10
 15   continue
c
      nc=0
      if(nc1.eq.0) return
c
c     At this point, new configurations have been loaded into
c     xx(jBond,ic1),ic1=1,...,nc1
c
c     Is there only one configuration?
      if(nc1.eq.1) then
         nc=nc+1
         write(2) (xx(j,1),j=1,jBond)
c$$$           write(3,*) ' SymSearch write ',(xx(j,nc1),j=1,jBond)
         go to 150
      end if
c
c     Initially assume all configurations are distinct
      do ic1=1,nc1
         Distinct(ic1)=.true.
      end do
c
      do ic1=1,nc1
c     Skip configuration if it has been identified as not distinct.
         if(.not.Distinct(ic1)) go to 140
c
c     Write configuration ic1 and eliminate all other configurations
c     equivalent to ic1.
         write(2) (xx(j,ic1),j=1,jBond)
c$$$           write(3,*) ' SymSearch write ',(xx(j,nc1),j=1,jBond)
         nc=nc+1
c
c     Test whether any other new configurations are equivalent to
c     configuration ic1 and eliminate them.  Skip if we are on the last
c     configuration.
         if(ic1.eq.nc1) go to 150
c
         do jc1=ic1+1,nc1
            if(Distinct(jc1)) then
               do iGv=1,nGv
                  do j=1,nBonds
c
                     if(xx(j,jc1).ne. iFlip(j,iGv)*
     >                    xx(jGv(j,iGv),ic1)) then
                        go to 25 ! This permuation fails to make ic1
                                 ! and jc1 equivalent.  Try another
                                 ! permuation.
                     end if
                  end do        ! End j-loop over bonds
c
c     Program reaches this point if terms ic1 and jc1 are equivalent
c     according to permutation iGv.  Eliminate configuration jc1.
                  Distinct(jc1)=.false. ! Eliminate configuration
                                               ! jc1.
                  go to 35      ! Try another new configuration jc1.
c
c     Program reaches statement 25 if a permutation fails to make
c     configurations ic1 and jc1 equivalent.  Try another permutation.
c
 25               continue
               end do           ! End iGv-loop
            end if              ! End Distinct(jc1) if-block
c
 35         continue
         end do                 ! End jc1-loop
c
 140     continue
      end do                    ! End ic1-loop over nc1 new
                                ! configurations
c
 150  continue
      close(1)
c
      return
      end
c
