      integer, parameter :: kShortInt=selected_int_kind(3) ! hold bond values
c
      integer, parameter  :: maxVertices=ceiling(real(maxBonds)/2.0)
c
c     The argument of selected_int_kind in the next statement should be
c     the number of digits in the maximum value of an invariant, which
c     should be close to the number of digits in the expected number of
c     bonds.
      integer, parameter :: kInvValue=selected_int_kind(6)
c
      integer            :: nBonds,nVertices,nGv
c
      logical            :: Distinct(maxSymBlock)
c
c     Bond configurations
      integer(kind=kShortInt) :: x(maxBonds),x1(maxBonds), ! arrays to
     > xx(maxBonds,maxSymBlock)                            ! hold config
c
c     Buffers for deal
      integer, parameter :: nxBuffer=50
      integer            :: xBufferPop(maxInvValues)
      integer(kind=kShortInt) :: xBuffer(maxBonds,nxBuffer,maxInvValues)
      integer InvSortValBuff(maxInvForDeal,nxBuffer,maxInvValues)
c
c     Vertex in/out bond counts
      integer(kind=kShortInt) :: vin(maxVertices),vout(maxVertices),
     >     vin0(maxVertices),vout0(maxVertices),
     >     vinMax(maxVertices),voutMax(maxVertices),
     >     voutMin(maxVertices)
c
c     Bond lists and group permutations
      integer            :: Bonds(2,maxBonds), Gv(maxVertices
     >     ,maxGroupOrder),BondIndex(maxVertices,maxVertices),
     >     jGv(maxBonds,maxGroupOrder),BondMap(maxBonds),
     $     BondMap2(maxBonds)
      integer(kind=kShortInt) :: iFlip(maxBonds,maxGroupOrder)
     >     ,BondSign(maxVertices,maxVertices)
c
c     Invariant arrays
      integer                 ::
     >     Invariants(3,maxGroupOrder,maxInvariants)
      integer(kind=kInvValue) :: 
     >     InvValueList(0:maxInvValues,0:maxInvariants)
      integer(kind=kShortInt) :: BondProduct(maxBonds,maxBonds)
      integer(kind=kInvValue) InvValues(0:maxInvariants)
      integer                 :: nInv,nInvValue(maxInvariants),
     >     InvValuePop(maxInvValues,maxInvariants),
     >     ActiveInvList(maxInvariants),nActiveInv,lInv(maxInvariants),
     >     BestActiveInvList(maxInvForDeal),nInvForDeal,nBestActiveInv,
     >     InvSortValues(maxInvForDeal),
     >     nSortFiles,nWrite(maxSortFiles),jSortFiles(maxSortFiles)
      integer                 ::
     >     IInvSortValues(maxInvForDeal,maxSymBlock)
c
c     Arrays for dealing configs to separate files
      integer, parameter      :: nCharXFilesForDeal=
     >     maxInvForDeal*4+2
c     File name character arrays
      character BaseFolder*150,FileName*170
      character*200 SortFileList(maxSortFiles)
      character*3 ext(maxInvValues)
c
c     Controls
      integer :: InvariantThreshold0, InvariantThreshold,
     >     maxInvariantSampleSize
      logical :: VERBOSE,DEBUG,REORDER,UseInvariants
c
c
      common /GraphEnumeration/ nBonds,nVertices,nGV,
     >     Bonds,Gv,jGv,BondIndex,BondSign,BondMap,BondMap2,iFlip,
     $     x,x1,xx,vin0,vout0,vin,vout,vinMax,voutMax
      common /Invariants/ nInv,lInv, InvValuePop,nInvValue,
     >     ActiveInvList,nActiveInv,BestActiveInvList,nInvForDeal,
     >     nBestActiveInv,
     >     InvValueList,Invariants,InvValues,BondProduct,Distinct
      common /GraphFiles/ nSortFiles,nWrite,jSortFiles,BaseFolder,
     >     FileName,ext,SortFileList
      common /GraphIO/ xBuffer,xBufferPop
      common /Controls/ VERBOSE,DEBUG,REORDER,UseInvariants,
     $     InvariantThreshold0,InvariantThreshold,
     >     maxInvariantSampleSize
