      integer nVertUnitMax,nBondsUnitMax,nVertSimMax,nBondsSimMax,
     $     nInvMax,nGenMax,nSymMax,nBondPairsMax,maxPrime,jobHBONDS,
     $     jobGENINVAR,LOGF
      logical DEBUG,TERMINATE,CELLBOUNDARY,SIMCELL,COVERCELL,COVERNP
      real*8 TOL_ZERO,TOL_INTEGER,TOL_HBOND(2),TOL_VV,PI
c
c -- Maximum array dimensions
      parameter(nVertUnitMax  = 150            ) ! Largest # of vertices in unit cell
      parameter(nBondsUnitMax = 2*nVertUnitMax ) ! Largest # of bonds in unit cell
      parameter(nVertSimMax   = 50000          ) ! Largest # of vertices
      parameter(nBondsSimMax  = 2*nVertSimMax  ) ! Largest # of bonds
      parameter(nInvMax       = 2500           ) ! Largest # of graph invariants 
      parameter(nGenMax       = 10             ) ! Largest # of generators
      parameter(nSymMax       = 13000          ) ! Largest # of symmetry elements
      parameter(nBondPairsMax = 100            ) ! Largest # of bond pairs kept for each invariant
      parameter(maxPrime      = 1000           ) ! Largest prime expected for prime factorization
c
c -- Tolerances
      parameter(TOL_ZERO      = 1.d-10         ) ! Test if real*8 is zero
      parameter(TOL_INTEGER   = 1.00000000001d0) ! Used to convert real*8(close to being integer) to integer
c
c -- Initialize some parameters
      parameter(CELLBOUNDARY  = .true.         ) ! Write cell boundary to file
c
c -- Debugging
      parameter(DEBUG         = .true.         ) ! Verbose output
c
c -- Constants
      parameter(PI            = 3.1415926535d0 ) ! PI
c
c -- Log File
      parameter(LOGF          = 21             ) ! Unit # for MkInvar.log
c
c -- Common Blocks
      common /param/ TOL_HBOND,TOL_VV,jobHBONDS,jobGENINVAR,TERMINATE,
     $     SIMCELL,COVERCELL,COVERNP
